--thanks to youresam for recreating the danzeff keyboard in lua and danzel for making the danzeff keyboard

displaykeyboard = false
keyboard = {x = 0, y = 0, mode = 1, key = 5, buffer = "", key_img = Image.load("danzeff/keys1.png"), key_img2 = Image.load("danzeff/keys2.png")}
keyboard.key_values = {
	"a,bc","d.ef","g!hi",
	"j-kl","m\001 n","o?pq",
	"r(st","u:vw","x)yz",
					  
	"A^BC","D@EF","G*HI",
	"J_KL","M\001 N",'O"PQ',
	"R=ST","U;VW","X/YZ",
					  
	"\0\0\0001","\0\0\0002","\0\0\0003",
	"\0\0\0004","\0\001 5","\0\0\0006",
	"\0\0\0007","\0\0\0008","\0\00009",
					  
	"(,.)","<\"'>","[-_]",
	"{!?}","\0\001 \0","\\+=/",
	"@:;#","$~`%","^"..string.char(15)..string.char(22).."&"
}

function keyboard.process(x,y,ctrldata,oldctrldata)
	keyboard.mode = 1
	if ctrldata:l() then
		keyboard.mode = 5
	end
	if ctrldata:r() then
		keyboard.mode = keyboard.mode + 2
	end

	if ctrldata:up() or ctrldata:down() then
		if inputtimer > 20 then inputtimer = 15 end
		inputtimer = inputtimer + 1
	else
		inputtimer = 0
	end

	local tx = math.floor((ctrldata:analogX()+128)/86)
	local ty = math.floor((ctrldata:analogY()+128)/86)+1
	keyboard.key = ty*3-(2-tx)

	if keyboard.mode == 7 then
		screen:blit(x,y,keyboard.key_img2,0,0,150,150)
	else
		screen:blit(x,y,keyboard.key_img,((keyboard.mode+1)/2-1)*150,0,150,150)
	end
	local tx = math.mod(keyboard.key,3)
	if tx == 0 then tx = 2 else tx = tx - 1 end
	local ty = math.floor(keyboard.key/10*3)
	if keyboard.mode > 4 then
		screen:blit(x+tx*43,y+ty*43,keyboard.key_img2,tx*64 + ((keyboard.mode+1-4)/2-1)*192,ty*64+150,64,64)
	else
		screen:blit(x+tx*43,y+ty*43,keyboard.key_img,tx*64 + ((keyboard.mode+1)/2-1)*192,ty*64+150,64,64)
	end

	if ctrldata:up() and (not oldctrldata:up() or inputtimer > 20) then
		keyboard.buffer = "\001"
		return
	elseif ctrldata:down() and (not oldctrldata:down() or inputtimer > 20) then
		keyboard.buffer = "\n"
		return
	end

	local t = 0
	if ctrldata:square() and not oldctrldata:square() then
		t = 1
	elseif ctrldata:triangle() and not oldctrldata:triangle() then
		t = 2
	elseif ctrldata:cross() and not oldctrldata:cross() then
		t = 3
	elseif ctrldata:circle() and not oldctrldata:circle() then
		t = 4
	end
	if t ~= 0 then
		t = string.sub(keyboard.key_values[((keyboard.mode+1)/2-1)*9+keyboard.key],t,t)
		if t ~= "\r" then
			keyboard.buffer = t
		end
	end
end

function keyboard.typeToString(str)
	if not displaykeyboard then displaykeyboard = true end
	if keyboard.buffer == "\001" and str ~= "" then
		str = string.sub(str,1,-2)
	elseif keyboard.buffer ~= "\000" then
		str = str..keyboard.buffer
	end
	keyboard.buffer = ""
	return str
end
