dofile("keyboard.lua")
lightgrey = Color.new(192,192,192)
function clearTilemap()
	for i = 1, fieldheight do
		lmtilemap[i] = {}
		for j = 1, fieldwidth do
			lmtilemap[i][j] = blank
		end
	end
end

function generatelmfieldimg()
	for i = 1, fieldheight do
		for j = 1, fieldwidth do
			lmfieldimg:blit((j-1)*32,(i-1)*32,lmtilemap[i][j])
		end
	end
end

function drawlmPathways()
	lmtilemap[lmcheckpoints[table.getn(lmcheckpoints)].y+1][lmcheckpoints[table.getn(lmcheckpoints)].x+1] = path
	for i = 1, table.getn(lmcheckpoints)-1 do
		lmtilemap[lmcheckpoints[i].y+1][lmcheckpoints[i].x+1] = path
		local xd = lmcheckpoints[i].x - lmcheckpoints[i+1].x
		local yd = lmcheckpoints[i].y - lmcheckpoints[i+1].y
		if yd < 0 then
			for j = 1, math.abs(yd) do
				lmtilemap[lmcheckpoints[i].y+1+j][lmcheckpoints[i].x+1] = path
			end
		elseif yd > 0 then
			for j = yd, 1, -1 do
				lmtilemap[lmcheckpoints[i].y+1-j][lmcheckpoints[i].x+1] = path
			end
		elseif xd < 0 then
			for j = 1, math.abs(xd) do
				lmtilemap[lmcheckpoints[i].y+1][lmcheckpoints[i].x+1+j] = path
			end
		elseif xd > 0 then
			for j = xd, 1, -1 do
				lmtilemap[lmcheckpoints[i].y+1][lmcheckpoints[i].x+1-j] = path
			end
		end
	end
end

menuimg = Image.createEmpty(96,272)
menubarimg = Image.load("lmmenuimg.png")
menuimg:blit(10,10,menubarimg)
menubarimg = nil
menuimg:print(31,14,"Creeps")
menuimg:print(31,44,"Turrets")
menuimg:print(31,74,"Waves")
menuimg:print(31,164,"Wavetime")
menuimg:print(31,194,"Save map")
menuimg:print(31,224,"Nuke map")
menuselect = 1

lmlives = 20
lmmoney = 100
creepInterval = 30
waveInterval = 600
lmturretTypes = {}
lmcreepTypes = {}
lmwaves = {}
lmcheckpoints = {}
lmfieldimg = Image.createEmpty(fieldwidth*32,fieldheight*32)
lmtilemap = {}
clearTilemap()
generatelmfieldimg()

lmc = {x=0,y=0}

inmenu = false

while true do
	screen:clear(lightgrey)
	pad = Controls.read()

	screen:blit(0,0,lmfieldimg)
	screen:blit(384,0,menuimg)

	if not inmenu then
		if pad:left() and not oldpad:left() and lmc.x > 0 then
			lmc.x = lmc.x - 1
		elseif pad:right() and not oldpad:right() and lmc.x < (fieldwidth-1) then
			lmc.x = lmc.x + 1
		elseif pad:up() and not oldpad:up() and lmc.y > 0 then
			lmc.y = lmc.y - 1
		elseif pad:down() and not oldpad:down() and lmc.y < (fieldheight-1) then
			lmc.y = lmc.y + 1
		end

		if pad:cross() and not oldpad:cross() then
			if (table.getn(lmcheckpoints) < 1 and (lmc.x == 0 or lmc.x == fieldwidth-1 or lmc.y == 0 or lmc.y == fieldheight-1)) or (table.getn(lmcheckpoints) ~= 0 and ((lmc.x == lmcheckpoints[table.getn(lmcheckpoints)].x or lmc.y == lmcheckpoints[table.getn(lmcheckpoints)].y) and (table.getn(lmcheckpoints) < 2 or (lmc.x ~= lmcheckpoints[table.getn(lmcheckpoints)-1].x and lmc.y ~= lmcheckpoints[table.getn(lmcheckpoints)-1].y)))) then
				table.insert(lmcheckpoints,{x = lmc.x,y = lmc.y})
				drawlmPathways()
				generatelmfieldimg()
			end
		end

		if pad:circle() and not oldpad:circle() then
			if table.getn(lmcheckpoints) > 0 then
				table.remove(lmcheckpoints,table.getn(lmcheckpoints))
				clearTilemap()
				if table.getn(lmcheckpoints) > 0 then
					drawlmPathways()
				end
				generatelmfieldimg()
			end
		end
		if lmtilemap[lmc.y+1][lmc.x+1] ~= path then
			screen:blit(lmc.x*32,lmc.y*32,greenimg)
		else
			screen:blit(lmc.x*32,lmc.y*32,redimg)
		end
	elseif inmenu then
		if pad:up() and not oldpad:up() and menuselect > 1 then
			menuselect = menuselect - 1
		elseif pad:down() and not oldpad:down() and menuselect < 8 then
			menuselect = menuselect + 1
		end
		screen:print(385,menuselect*30-16,">",black)

		if menuselect == 4 then --lives
			if pad:left() and not oldpad:left() and lmlives > 1 then lmlives = lmlives - 1 elseif pad:right() and not oldpad:right() then lmlives = lmlives + 1 end
		elseif menuselect == 5 then --money
			if pad:left() and not oldpad:left() and lmmoney > 1 then lmmoney = lmmoney - 1 elseif pad:right() and not oldpad:right() then lmmoney = lmmoney + 1 end
		end

		if pad:cross() and not oldpad:cross() then
			if menuselect == 1 then --creeps
				function ctrs()
					if table.getn(lmcreepTypes) > 0 then return selects[6] else return "No creepTypes yet" end
				end
				selected = 1
				creepimgs = System.listDirectory("./creepimgs")
				table.remove(creepimgs,1)
				table.remove(creepimgs,1)
				cci = Image.load("creepimgs/"..creepimgs[1].name)
				cy = 0
				selects = {1,2,1,10,0,1}
				while true do
					screen:clear(white)
					oldpad = pad
					pad = Controls.read()					

					screen:print(10,2,"Creep image: "..creepimgs[selects[1]].name)
					screen:print(10,12,"Creep speed: "..selects[2])
					screen:print(10,22,"Creep value: "..selects[3])
					screen:print(10,32,"Creep HP: "..selects[4])
					screen:print(10,42,"Save creeptype")
					screen:print(10,52,"Remove creeptype: "..(ctrs()))

					screen:blit(400,cy,cci)
					cy = cy - selects[2]
					if cy < -32 then cy = 272 end


					screen:print(1,selected*10-8,">")
					if pad:left() and not oldpad:left() and selects[selected] > 1 then
						selects[selected] = selects[selected] - 1
						if selected == 1 then
							cci = Image.load("creepimgs/"..creepimgs[selects[1]].name)
						end
					elseif pad:right() and not oldpad:right() then
						selects[selected] = selects[selected] + 1
						if selected == 1 then
							if selects[1] > table.getn(creepimgs) then selects[1] = table.getn(creepimgs) end
							cci = Image.load("creepimgs/"..creepimgs[selects[1]].name)
						elseif selected == 2 then
							if selects[2] > 8 then selects[2] = 8 end
						elseif selected == 6 then
							if selects[6] > table.getn(lmcreepTypes) then selects[6] = table.getn(lmcreepTypes) end
							if selects[6] < 1 then selects[6] = 1 end
						end
					elseif pad:up() and not oldpad:up() then
						selected = selected - 1
					elseif pad:down() and not oldpad:down() then
						selected = selected + 1
					end

					if pad:cross() and not oldpad:cross() then
						if selected == 5 then
							table.insert(lmcreepTypes,{img = string.sub(creepimgs[selects[1]].name,1,-5),speed = selects[2], value = selects[3],hp = selects[4]})
						elseif selected == 6 then
							if table.getn(lmcreepTypes) > 0 and selects[6] <= table.getn(lmcreepTypes) then
								table.remove(lmcreepTypes, selects[6])
								if selects[6] > table.getn(lmcreepTypes) then selects[6] = table.getn(lmcreepTypes) end
								if selects[6] < 1 then selects[6] = 1 end
							end
						end
					end

					if selected > 6 then selected = 1 elseif selected < 1 then selected = 6 end

					if pad:circle() and not oldpad:circle() then break end
					screen.waitVblankStart()
					screen.flip()
				end
			elseif menuselect == 2 then --turrets
				function ttrs()
					if table.getn(lmturretTypes) > 0 then return selects[11] else return "No turret types yet" end
				end
				bimgs = System.listDirectory("./bimgs")
				table.remove(bimgs,1)
				table.remove(bimgs,1)
				tbi = Image.load("bimgs/"..bimgs[1].name)
				ttn = "Turret type name"
				selected = 1
				selects = {1,10,30,64,5,1,0,0,0,0,1}
				while true do
					screen:clear(white)
					oldpad = pad
					pad = Controls.read()
					
					screen:print(10,2,"Name: "..ttn)
					screen:print(10,12,"Cost: "..selects[2])
					screen:print(10,22,"Frames between shots (30 = 1 second): "..selects[3])
					screen:print(10,32,"Range (pixels, 32 = 1 square, 256 max): "..selects[4])
					screen:print(10,42,"Damage: "..selects[5])
					screen:print(10,52,"Bullet image:")
					screen:print(10,62,"Red: "..selects[7])
					screen:print(10,72,"Green: "..selects[8])
					screen:print(10,82,"Blue: "..selects[9])
					screen:print(10,92,"Save turrettype")
					screen:print(10,102,"Remove turrettype: "..(ttrs()))

					screen:blit(112,56-(tbi:height()/2),tbi)
					drawRect(40,122,32,32,Color.new(selects[7],selects[8],selects[9]))
					screen:drawLine(56,138,40,138,Color.new(selects[7],selects[8],selects[9]))

					screen:print(1,selected*10-8,">")
					if not typing then
						if pad:left() and selects[selected] > 1 then
							if (selected > 6 and selected < 10) or not oldpad:left() then
								selects[selected] = selects[selected] - 1
								if selected == 6 then
									tbi = Image.load("bimgs/"..bimgs[selects[6]].name)
								end
							end
						elseif pad:right() then
							if (selected > 6 and selected < 10) or not oldpad:right() then
								selects[selected] = selects[selected] + 1
								if selects[selected] > 255 and selected > 6 and selected < 10 then selects[selected] = 255
								elseif selected == 6 then
									if selects[6] > table.getn(bimgs) then selects[6] = table.getn(bimgs) end
									tbi = Image.load("bimgs/"..bimgs[selects[6]].name)
								elseif selected == 11 then
									if selects[11] > table.getn(lmturretTypes) then selects[11] = table.getn(lmturretTypes) end
									if selects[11] < 1 then selects[11] = 1 end
								end
							end
						elseif pad:up() and not oldpad:up() then
							selected = selected - 1
						elseif pad:down() and not oldpad:down() then
							selected = selected + 1
						end

						if pad:cross() and not oldpad:cross() then
							if selected == 1 then
								typing = true
							elseif selected == 10 then
								table.insert(lmturretTypes,{name = ttn, cost = selects[2],rtfr = selects[3], range = selects[4], dmg = selects[5], bimg = string.sub(bimgs[selects[6]].name,1,-5), r = selects[7],g = selects[8],b = selects[9]})
							elseif selected == 11 then
								if table.getn(lmturretTypes) > 0 and selects[11] <= table.getn(lmturretTypes) then
									table.remove(lmturretTypes, selects[11])
									if selects[11] > table.getn(lmturretTypes) then selects[11] = table.getn(lmturretTypes) end
									if selects[11] < 1 then selects[11] = 1 end
								end
							end
						end
						if pad:circle() and not oldpad:circle() then break end
					elseif typing then
						screen:print(string.len(ttn)*8+58,2,"_")
						keyboard.process(330,122,pad,oldpad)
						ttn = keyboard.typeToString(ttn)
						if string.sub(ttn,-1) == "\n" then
							ttn = string.sub(ttn,1,-2)
							typing = false
						end
					end

					if selected > 11 then selected = 1 elseif selected < 1 then selected = 11 end

					screen.waitVblankStart()
					screen.flip()
				end
			elseif menuselect == 3 and table.getn(lmcreepTypes) > 0 then --waves
				function wrs()
					if table.getn(lmwaves) > 0 then return selects[6] else return "No waves yet" end
				end
				selected = 1
				creepimgs = System.listDirectory("./creepimgs")
				table.remove(creepimgs,1)
				table.remove(creepimgs,1)
				cci = Image.load("creepimgs/"..lmcreepTypes[1].img..".png")
				selects = {1,1,1,1,0,1}
				while true do
					screen:clear(white)
					oldpad = pad
					pad = Controls.read()
					
					screen:print(10,2,"Creeptype: "..selects[1])
					screen:print(10,12,"Number of creeps: "..selects[2])
					screen:print(10,22,"Value multiplier: "..selects[3])
					screen:print(10,32,"HP multiplier: "..selects[4])
					screen:print(10,42,"Add this wave")
					screen:print(10,52,"Remove wave: "..(wrs()))

					screen:print(1,selected*10-8,">")

					screen:blit(10,72,cci)
					screen:print(10,62,"Wave info:")
					screen:print(10,106,selects[2].." creeps")
					screen:print(10,116,"Value: "..lmcreepTypes[selects[1]].value*selects[3].." each")
					screen:print(10,126,"HP: "..lmcreepTypes[selects[1]].hp*selects[4].." each")
					screen:print(10,136,"Speed: "..lmcreepTypes[selects[1]].speed)
					if pad:left() and not oldpad:left() and selects[selected] > 1 then
						selects[selected] = selects[selected] - 1
						if selected == 1 then
							cci = Image.load("creepimgs/"..lmcreepTypes[selects[1]].img..".png")
						end
					elseif pad:right() and not oldpad:right() then
						selects[selected] = selects[selected] + 1
						if selected == 1 then
							if selects[1] > table.getn(lmcreepTypes) then selects[1] = table.getn(lmcreepTypes) end
							cci = Image.load("creepimgs/"..lmcreepTypes[selects[1]].img..".png")
						elseif selected == 6 then
							if selects[6] > table.getn(lmwaves) then selects[6] = table.getn(lmwaves) end
							if selects[6] < 1 then selects[6] = 1 end
						end
					elseif pad:up() and not oldpad:up() then
						selected = selected - 1
					elseif pad:down() and not oldpad:down() then
						selected = selected + 1
					end

					if pad:cross() and not oldpad:cross() then
						if selected == 5 then
							table.insert(lmwaves,{type = selects[1],numCreeps = selects[2], vm = selects[3],hpm = selects[4]})
						elseif selected == 6 then
							if table.getn(lmwaves) > 0 and selects[6] <= table.getn(lmwaves) then
								table.remove(lmwaves, selects[6])
								if selects[6] > table.getn(lmwaves) then selects[6] = table.getn(lmwaves) end
								if selects[6] < 1 then selects[6] = 1 end
							end
						end
					end

					if selected > 6 then selected = 1 elseif selected < 1 then selected = 6 end

					if pad:circle() and not oldpad:circle() then break end
					screen.waitVblankStart()
					screen.flip()
				end
			elseif menuselect == 6 then --time
				settingtime = true
				oldwaveInterval = waveInterval
				oldcreepInterval = creepInterval
				times = {waveInterval,creepInterval}
				selected = 1
				while settingtime do
					screen:clear(white)
					oldpad = pad
					pad = Controls.read()
					
					screen:print(10,2,"Frames between waves:"..times[1])
					screen:print(10,12,"Frames between creeps:"..times[2])
					screen:print(10,32,"30 frames per second")
					screen:print(10,42,"Press X to save times or O to cancel")
					screen:print(1,selected*10-8,">")
					if pad:left() then
						if selected == 1 or not oldpad:left() then
							times[selected] = times[selected] - 1
						end
					elseif pad:right()  then
						if selected == 1 or not oldpad:right() then
							times[selected] = times[selected] + 1
						end
					elseif pad:up() and not oldpad:up() then
						selected = selected - 1
					elseif pad:down() and not oldpad:down() then
						selected = selected + 1
					end
					if pad:cross() and not oldpad:cross() then settingtime = false end
				
					if selected > 2 then selected = 1 elseif selected < 1 then selected = 2 end

					if pad:circle() then waveInterval = oldwaveInterval creepInterval = oldcreepInterval settingtime = false end
					screen.waitVblankStart()
					screen.flip()
				end
				waveInterval = times[1]
				creepInterval = times[2]
			elseif menuselect == 7 then --save
				mapname = "Map "..(table.getn(System.listDirectory("maps"))-2)
				while true do
					screen:clear(white)
					pad = Controls.read()
					keyboard.process(0,122,pad,oldpad)
					mapname = keyboard.typeToString(mapname)
					if string.sub(mapname,-1) == "\n" then
						mapname = string.sub(mapname,1,-2)
						sf = io.open("./maps/"..mapname..".txt","w")
						for i = 1, table.getn(lmcreepTypes) do
							sf:write("newCreepType(Image.load(\"creepimgs/"..lmcreepTypes[i].img..".png\"),"..lmcreepTypes[i].speed..","..lmcreepTypes[i].value..","..lmcreepTypes[i].hp..")\n")
						end
						for i = 1, table.getn(lmturretTypes) do
							sf:write("newTurretType(\""..lmturretTypes[i].name.."\","..lmturretTypes[i].cost..","..lmturretTypes[i].rtfr..","..lmturretTypes[i].range..","..lmturretTypes[i].dmg..",Image.load(\"bimgs/"..lmturretTypes[i].bimg..".png\"),Color.new("..lmturretTypes[i].r..","..lmturretTypes[i].g..","..lmturretTypes[i].b.."))\n")
						end
						for i = 1, table.getn(lmcheckpoints) do
							sf:write("newCheckpoint("..lmcheckpoints[i].x..","..lmcheckpoints[i].y..")\n")
						end
						for i = 1, table.getn(lmwaves) do
							sf:write("addWave("..lmwaves[i].type..","..lmwaves[i].numCreeps..","..lmwaves[i].hpm..","..lmwaves[i].vm..")\n")
						end
						sf:write("\nlives = "..lmlives.."\nmoney = "..lmmoney.."\ncreepSendInterval = "..creepInterval.."\ntimeBetweenWaves = "..waveInterval)
						sf:close()
						break
					end
					screen:print(2,2,"Name of map: "..mapname..".txt")
					screen:print(2,32,"Press down to save")
					screen.waitVblankStart()
					screen.flip()
					oldpad = pad
				end
			elseif menuselect == 8 then --nuke
				lmturretTypes = {}
				lmcreepTypes = {}
				lmwaves = {}
				lmcheckpoints = {}
				lmfieldimg = Image.createEmpty(fieldwidth*32,fieldheight*32)
				lmtilemap = {}
				clearTilemap()
				generatelmfieldimg()
			end
		end
	end

	screen:print(415,104,lmlives.." lives")
	screen:print(415,134,lmmoney)

	if pad:select() and not oldpad:select() then
		if inmenu then inmenu = false else inmenu = true end
	end

	if pad:start() and not oldpad:start() then break end
	screen.waitVblankStart()
	screen.flip()
	oldpad = pad
end
