bullets = {}
bulletSpeed = 10

function processBullets()
	local i = 1
	local j = 1
	local bullethit = false
	while i <= table.getn(bullets) do --while instead of for so that an error isn't caused when bullets are removed from the table
		bullethit = false
		bullets[i].x = bullets[i].x + bullets[i].xm
		bullets[i].y = bullets[i].y + bullets[i].ym
		j = 1
		while j <= table.getn(creeps) do --again while instead of for so when creeps die errors don't come
			if collision(bullets[i],creeps[j]) then
				creeps[j].hp = creeps[j].hp - bullets[i].dmg
				table.remove(bullets,i)
				bullethit = true
				if creeps[j].hp <= 0 then
					money = money + creeps[j].value
					table.remove(creeps,j)
				end
				break
			end
			j = j + 1
		end
		if not bullethit then
			if bullets[i].x > 384 or bullets[i].x < 0 or bullets[i].y > 256 or bullets[i].y < 0 then
				table.remove(bullets,i)
			end
		end
		i = i + 1
	end
end

function getMuzzlePoint(x,y,tx,ty,ml)
	xd = x - tx
	yd = y - ty
	if yd == 0 then
		mx = ml
		my = 0
	elseif xd == 0 then
		mx = 0
		my = ml
	else
		angle = math.atan(math.abs(xd)/math.abs(yd))
		mx = math.sin(angle)*ml
		my = math.cos(angle)*ml
	end
	if xd > 0 then mx = -mx end
	if yd > 0 then my = -my end
	mx = mx + x
	my = my + y
	return {x = mx,y = my}
end

function newBullet(x,y,mx,my,dmg,img,ml,bs)
	bs = bs or bulletSpeed
	xm = ((mx - x)/ml)*bs
	ym = ((my - y)/ml)*bs
	table.insert(bullets,{x = mx, y = my, w = img:width(), h = img:height(), xm = xm, ym = ym, dmg = dmg, img = img})
end
